Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class SimpleMappingExpression

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.expr.SimpleMappingExpression

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, MappingFunction, java.io.Serializable, javax.xml.transform.SourceLocator

public final class SimpleMappingExpression
extends ComputedExpression
implements MappingFunction

A simple mapping expression is an expression A/B where B has a static type that is an atomic type. For example, * / name().

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`SimpleMappingExpression(Expression start, Expression step, boolean isHybrid)` Constructor

Method Summary
`int` | `computeCardinality()` Determine the static cardinality of the expression
`int` | `computeDependencies()` Determine which aspects of the context the expression depends on.
`int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`void` | `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic print of expression structure
`boolean` | `equals(java.lang.Object other)` Is this expression the same as another expression?
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items returned by this exprssion
`Expression` | `getStartExpression()` Get the start expression (the left-hand operand)
`Expression` | `getStepExpression()` Get the step expression (the right-hand operand)
`int` | `hashCode()` get HashCode for comparing two expressions
`SequenceIterator` | `iterate(XPathContext context)` Iterate the path-expression in a given context
`java.util.Iterator` | `iterateSubExpressions()` Get the immediate subexpressions of this expression
`java.lang.Object` | `map(Item item, XPathContext context)` Mapping function, from a node returned by the start iteration, to a sequence returned by the child.
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `promote(PromotionOffer offer)` Promote this expression if possible
`Expression` | `simplify(StaticContext env)` Simplify an expression
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.ComputedExpression
`adoptChildExpression, checkPermittedContents, computeStaticProperties, doPromotion, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, suppressValidation, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SimpleMappingExpression

    public SimpleMappingExpression(Expression start,
                                   Expression step,
                                   boolean isHybrid)

  Constructor

Parameters:
  `start` - A node-set expression denoting the absolute or relative set of nodes from which the navigation path should start.
  `step` - The step to be followed from each node in the start expression to yield a new node-set
  `isHybrid` - if true, indicates that we don't know statically whether the step expression will return nodes or atomic values. If false, we know it will return atomic values.

Method Detail

### getStartExpression

    public Expression getStartExpression()

  Get the start expression (the left-hand operand)

### getStepExpression

    public Expression getStepExpression()

  Get the step expression (the right-hand operand)

### getItemType

    public final ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by this exprssion

  Specified by:
    `getItemType` in interface `Expression`
  Parameters:
    `th` -
  Returns:
    the type of the step

### simplify

    public Expression simplify(StaticContext env)

  Simplify an expression

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `ComputedExpression`
  Returns:
    the simplified expression

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)

  Type-check the expression

  Specified by:
    `typeCheck` in interface `Expression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Description copied from interface: `Expression`
  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Specified by:
    `optimize` in interface `Expression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException`

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Specified by:
    `promote` in interface `Expression`
  Overrides:
    `promote` in class `ComputedExpression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Specified by:
    `iterateSubExpressions` in interface `Expression`
  Overrides:
    `iterateSubExpressions` in class `ComputedExpression`
  Returns:
    an iterator containing the sub-expressions of this expression

### computeDependencies

    public int computeDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE

  Overrides:
    `computeDependencies` in class `ComputedExpression`
  Returns:
    the depencies, as a bit-mask

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `ComputedExpression`

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality of the expression

  Specified by:
    `computeCardinality` in class `ComputedExpression`

### equals

    public boolean equals(java.lang.Object other)

  Is this expression the same as another expression?

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Iterate the path-expression in a given context

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `ComputedExpression`
  Parameters:
    `context` - the evaluation context
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### map

    public java.lang.Object map(Item item,
                                XPathContext context)
                         throws XPathException

  Mapping function, from a node returned by the start iteration, to a sequence returned by the child.

  Specified by:
    `map` in interface `MappingFunction`
  Parameters:
    `item` - The item to be mapped. If context is supplied, this must be the same as context.currentItem().
    `context` - The processing context. Some mapping functions use this because they require context information. Some mapping functions modify the context by maintaining the context item and position. In other cases, the context may be null.
  Returns:
    either (a) a SequenceIterator over the sequence of items that the supplied input item maps to, or (b) an Item if it maps to a single item, or (c) null if it maps to an empty sequence.
  Throws:
    `XPathException`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic print of expression structure

  Specified by:
    `display` in interface `Expression`
  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD